diff --git a/yummain.py b/yummain.py
index 9f79f4f..24bbe6c 100755
--- a/yummain.py
+++ b/yummain.py
@@ -29,13 +29,13 @@ from yum import Errors
 from yum import plugins
 from yum import logginglevels
 from yum import _
-from yum.i18n import to_unicode, utf8_width
+from yum.i18n import utf8_width, exception2msg
 import yum.misc
 import cli
-from utils import suppress_keyboard_interrupt_message, show_lock_owner, exception2msg
+from utils import suppress_keyboard_interrupt_message
 
 def main(args):
-    """This does all the real work"""
+    """Run the yum program from a command line interface."""
 
     yum.misc.setup_locale(override_time=True)
 
@@ -68,6 +68,51 @@ def main(args):
         if unlock(): return 200
         return 1
 
+    def exRepoError(e):
+        # For RepoErrors ... help out by forcing new repodata next time.
+        # XXX: clean only the repo that has failed?
+        base.cleanExpireCache()
+
+        msg = _("""\
+ One of the configured repositories failed (%(repo)s),
+ and yum doesn't have enough cached data to continue. At this point the only
+ safe thing yum can do is fail. There are a few ways to work "fix" this:
+
+     1. Contact the upstream for the repository and get them to fix the problem.
+
+     2. Reconfigure the baseurl/etc. for the repository, to point to a working
+        upstream. This is most often useful if you are using a newer
+        distribution release than is supported by the repository (and the
+        packages for the previous distribution release still work).
+
+     3. Disable the repository, so yum won't use it by default. Yum will then
+        just ignore the repository until you permanently enable it again or use
+        --enablerepo for temporary usage:
+
+            yum-config-manager --disable %(repoid)s
+
+     4. Configure the failing repository to be skipped, if it is unavailable.
+        Note that yum will try to contact the repo. when it runs most commands,
+        so will have to try and fail each time (and thus. yum will be be much
+        slower). If it is a very temporary problem though, this is often a nice
+        compromise:
+
+            yum-config-manager --save --setopt=%(repoid)s.skip_if_unavailable=true
+""")
+
+        repoui = _('Unknown')
+        repoid = _('<repoid>')
+        if hasattr(e, 'repo'):
+            repoid = e.repo.id
+            repoui = e.repo.name
+
+        msg = msg % {'repoid' : repoid, 'repo' : repoui}
+
+        logger.critical('\n\n%s\n%s', msg, exception2msg(e))
+
+        if unlock(): return 200
+        return 1
+
     def unlock():
         try:
             base.closeRpmDB()
@@ -89,6 +134,23 @@ def main(args):
     logger = logging.getLogger("yum.main")
     verbose_logger = logging.getLogger("yum.verbose.main")
 
+    # Try to open the current directory to see if we have 
+    # read and execute access. If not, chdir to /
+    try:
+        f = open(".")
+    except IOError, e:
+        if e.errno == errno.EACCES:
+            logger.critical(_('No read/execute access in current directory, moving to /'))
+            os.chdir("/")
+    else:
+        f.close()
+    try:
+        os.getcwd()
+    except OSError, e:
+        if e.errno == errno.ENOENT:
+            logger.critical(_('No getcwd() access in current directory, moving to /'))
+            os.chdir("/")
+
     # our core object for the cli
     base = cli.YumBaseCli()
 
@@ -100,46 +162,20 @@ def main(args):
         return exPluginExit(e)
     except Errors.YumBaseError, e:
         return exFatal(e)
+    except (OSError, IOError), e:
+        return exIOError(e)
 
-    # Try to open the current directory to see if we have 
-    # read and write access. If not, chdir to /
     try:
-        f = open(".")
-    except IOError, e:
-        if e.errno == errno.EACCES:
-            logger.critical(_('No read/write access in current directory, moving to /'))
-            os.chdir("/")
-    else:
-        close(f)
-
-    lockerr = ""
-    while True:
-        try:
-            base.doLock()
-        except Errors.LockError, e:
-            if exception2msg(e) != lockerr:
-                lockerr = exception2msg(e)
-                logger.critical(lockerr)
-            if (e.errno not in (errno.EPERM, errno.EACCES) and
-                not base.conf.exit_on_lock):
-                logger.critical(_("Another app is currently holding the yum lock; waiting for it to exit..."))
-                tm = 0.1
-                if show_lock_owner(e.pid, logger):
-                    tm = 2
-                time.sleep(tm)
-            elif e.errno in (errno.EPERM, errno.EACCES):
-                logger.critical(_("Can't create lock file; exiting"))
-                return 1
-            else:
-                logger.critical(_("Another app is currently holding the yum lock; exiting as configured by exit_on_lock"))
-                return 1
-        else:
-            break
+        base.waitForLock()
+    except Errors.YumBaseError, e:
+        return exFatal(e)
 
     try:
         result, resultmsgs = base.doCommands()
     except plugins.PluginYumExit, e:
         return exPluginExit(e)
+    except Errors.RepoError, e:
+        return exRepoError(e)
     except Errors.YumBaseError, e:
         result = 1
         resultmsgs = [exception2msg(e)]
@@ -154,7 +190,7 @@ def main(args):
         for msg in resultmsgs:
             verbose_logger.log(logginglevels.INFO_2, '%s', msg)
         if unlock(): return 200
-        return 0
+        return base.exit_code
     elif result == 1:
         # Fatal error
         for msg in resultmsgs:
@@ -173,6 +209,18 @@ def main(args):
             logger.critical(msg)
         if unlock(): return 200
         return 3
+
+    # Mainly for ostree, but might be useful for others.
+    if base.conf.usr_w_check:
+        usrinstpath = base.conf.installroot + "/usr"
+        usrinstpath = usrinstpath.replace('//', '/')
+        if (os.path.exists(usrinstpath) and
+            not os.access(usrinstpath, os.W_OK)):
+            logger.critical(_('No write access to %s directory') % usrinstpath)
+            logger.critical(_('  Maybe this is an ostree image?'))
+            logger.critical(_('  To disable you can use --setopt=usr_w_check=false'))
+            if unlock(): return 200
+            return 1
             
     # Depsolve stage
     verbose_logger.log(logginglevels.INFO_2, _('Resolving Dependencies'))
@@ -181,6 +229,8 @@ def main(args):
         (result, resultmsgs) = base.buildTransaction() 
     except plugins.PluginYumExit, e:
         return exPluginExit(e)
+    except Errors.RepoError, e:
+        return exRepoError(e)
     except Errors.YumBaseError, e:
         result = 1
         resultmsgs = [exception2msg(e)]
@@ -193,7 +243,7 @@ def main(args):
     if result == 0:
         # Normal exit
         if unlock(): return 200
-        return 0
+        return base.exit_code
     elif result == 1:
         # Fatal error
         for msg in resultmsgs:
@@ -223,6 +273,8 @@ def main(args):
         return_code = base.doTransaction()
     except plugins.PluginYumExit, e:
         return exPluginExit(e)
+    except Errors.RepoError, e:
+        return exRepoError(e)
     except Errors.YumBaseError, e:
         return exFatal(e)
     except KeyboardInterrupt:
@@ -238,16 +290,27 @@ def main(args):
         rpmdb_warn_checks()
         return_code = result
         if base._ts_save_file:
-            verbose_logger.info(_("Your transaction was saved, rerun it with: yum load-transaction %s") % base._ts_save_file)
+            verbose_logger.info(_("Your transaction was saved, rerun it with:\n yum load-transaction %s") % base._ts_save_file)
     elif return_code < 0:
         return_code = 1 # Means the pre-transaction checks failed...
+        #  This includes:
+        # . No packages.
+        # . Hitting N at the prompt.
+        # . GPG check failures.
+        if base._ts_save_file:
+            verbose_logger.info(_("Your transaction was saved, rerun it with:\n yum load-transaction %s") % base._ts_save_file)
     else:
         verbose_logger.log(logginglevels.INFO_2, _('Complete!'))
 
     if unlock(): return 200
-    return return_code
+    return return_code or base.exit_code
 
 def hotshot(func, *args, **kwargs):
+    """Profile the given function using the hotshot profiler.
+
+    :param func: the function to profile
+    :return: the return code given by the hotshot profiler
+    """
     import hotshot.stats
     fn = os.path.expanduser("~/yum.prof")
     prof = hotshot.Profile(fn)
@@ -257,6 +320,11 @@ def hotshot(func, *args, **kwargs):
     return rc
 
 def cprof(func, *args, **kwargs):
+    """Profile the given function using the cprof profiler.
+
+    :param func: the function to profile
+    :return: the return code given by the cprof profiler
+    """
     import cProfile, pstats
     fn = os.path.expanduser("~/yum.prof")
     prof = cProfile.Profile()
@@ -266,6 +334,10 @@ def cprof(func, *args, **kwargs):
     return rc
 
 def print_stats(stats):
+    """Print out information from a :class:`Stats` object.
+
+    :param stats: the :class:`Stats` object to print information from
+    """
     stats.strip_dirs()
     stats.sort_stats('time', 'calls')
     stats.print_stats(20)
@@ -273,7 +345,14 @@ def print_stats(stats):
     stats.print_stats(40)
 
 def user_main(args, exit_code=False):
-    """ This calls one of the multiple main() functions based on env. vars """
+    """Call one of the multiple main() functions based on environment variables.
+
+    :param args: command line arguments passed into yum
+    :param exit_code: if *exit_code* is True, this function will exit
+       python with its exit code when it has finished executing.
+       Otherwise, it will return its exit code.
+    :return: the exit code from yum execution
+    """
     errcode = None
     if 'YUM_PROF' in os.environ:
         if os.environ['YUM_PROF'] == 'cprof':
